"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from emissary_client_sdk.types import BaseModel
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class DeploymentDetailStatus(str, Enum):
    r"""The current status of the deployment"""

    PENDING = "Pending"
    DEPLOYING = "Deploying"
    DEPLOYED = "Deployed"
    FAILED = "Failed"
    CANCELLED = "Cancelled"
    TIMED_OUT = "TimedOut"


class DeploymentDetailTypedDict(TypedDict):
    r"""Deployment Object"""

    id: NotRequired[str]
    r"""The unique identifier for the deployment"""
    name: NotRequired[str]
    r"""The name of the deployment"""
    description: NotRequired[str]
    r"""A description of the deployment"""
    base_model: NotRequired[str]
    r"""The base model used for deployment"""
    status: NotRequired[DeploymentDetailStatus]
    r"""The current status of the deployment"""
    training_id: NotRequired[str]
    r"""The training job ID used for deployment"""
    checkpoint: NotRequired[int]
    r"""The checkpoint number used for deployment"""
    created_at: NotRequired[int]
    r"""The timestamp when the deployment was created"""
    updated_at: NotRequired[int]
    r"""The timestamp when the deployment was last updated"""


class DeploymentDetail(BaseModel):
    r"""Deployment Object"""

    id: Optional[str] = None
    r"""The unique identifier for the deployment"""

    name: Optional[str] = None
    r"""The name of the deployment"""

    description: Optional[str] = None
    r"""A description of the deployment"""

    base_model: Optional[str] = None
    r"""The base model used for deployment"""

    status: Optional[DeploymentDetailStatus] = None
    r"""The current status of the deployment"""

    training_id: Optional[str] = None
    r"""The training job ID used for deployment"""

    checkpoint: Optional[int] = None
    r"""The checkpoint number used for deployment"""

    created_at: Optional[int] = None
    r"""The timestamp when the deployment was created"""

    updated_at: Optional[int] = None
    r"""The timestamp when the deployment was last updated"""
