"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from emissary_client_sdk.types import BaseModel
from emissary_client_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetCompletionsFromDeploymentRequestBodyTypedDict(TypedDict):
    r"""Provide you prompt input for completions"""

    prompt: str
    r"""The input prompt for the deployment"""
    temperature: NotRequired[float]
    r"""The sampling temperature to use"""
    max_new_tokens: NotRequired[int]
    r"""The maximum number of new tokens to generate"""
    top_p: NotRequired[float]
    r"""The cumulative probability for token selection"""
    top_k: NotRequired[int]
    r"""The number of highest probability tokens to keep for top-k-filtering"""
    no_repeat_ngram_size: NotRequired[int]
    r"""The size of n-grams to avoid repeating"""
    do_sample: NotRequired[bool]
    r"""Whether to use sampling or not"""


class GetCompletionsFromDeploymentRequestBody(BaseModel):
    r"""Provide you prompt input for completions"""

    prompt: str
    r"""The input prompt for the deployment"""

    temperature: Optional[float] = None
    r"""The sampling temperature to use"""

    max_new_tokens: Optional[int] = None
    r"""The maximum number of new tokens to generate"""

    top_p: Optional[float] = None
    r"""The cumulative probability for token selection"""

    top_k: Optional[int] = None
    r"""The number of highest probability tokens to keep for top-k-filtering"""

    no_repeat_ngram_size: Optional[int] = None
    r"""The size of n-grams to avoid repeating"""

    do_sample: Optional[bool] = None
    r"""Whether to use sampling or not"""


class GetCompletionsFromDeploymentRequestTypedDict(TypedDict):
    project_id: str
    r"""The ID of the project to retrieve deployments for"""
    deployment_id: str
    r"""The ID of the deployment to get completions from"""
    request_body: GetCompletionsFromDeploymentRequestBodyTypedDict
    r"""Provide you prompt input for completions"""


class GetCompletionsFromDeploymentRequest(BaseModel):
    project_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the project to retrieve deployments for"""

    deployment_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the deployment to get completions from"""

    request_body: Annotated[
        GetCompletionsFromDeploymentRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""Provide you prompt input for completions"""


class GetCompletionsFromDeploymentResponseBodyTypedDict(TypedDict):
    r"""Successful operation"""

    id: NotRequired[str]
    r"""The unique identifier for the completion"""
    response: NotRequired[str]
    r"""The generated completion from the deployment"""


class GetCompletionsFromDeploymentResponseBody(BaseModel):
    r"""Successful operation"""

    id: Optional[str] = None
    r"""The unique identifier for the completion"""

    response: Optional[str] = None
    r"""The generated completion from the deployment"""
